Index: apps/app_voicemail.c
===================================================================
--- app_voicemail.c	(revision 113731)
+++ app_voicemail.c	(working copy)
@@ -34,6 +34,7 @@
  * during compilation.
  *
  *
+ * \note A flag 'i' is added to ignore the specified context and write to 'default'.
  *
  * \note  This file is now almost impossible to work with, due to all \#ifdefs.
  *        Feels like the database code before realtime. Someone - please come up
@@ -243,6 +244,7 @@
 	OPT_PREPEND_MAILBOX =  (1 << 4),
 	OPT_AUTOPLAY =         (1 << 6),
 	OPT_DTMFEXIT =         (1 << 7),
+	OPT_IGNORE_CONTEXT =   (1 << 8),
 } vm_option_flags;
 
 enum {
@@ -261,6 +263,7 @@
 	AST_APP_OPTION_ARG('d', OPT_DTMFEXIT, OPT_ARG_DTMFEXIT),
 	AST_APP_OPTION('p', OPT_PREPEND_MAILBOX),
 	AST_APP_OPTION_ARG('a', OPT_AUTOPLAY, OPT_ARG_PLAYFOLDER),
+	AST_APP_OPTION('i', OPT_IGNORE_CONTEXT),
 });
 
 static int load_config(int reload);
@@ -3637,6 +3640,13 @@
 		return -1;
 	}
 	/* The meat of recording the message...  All the announcements and beeps have been played*/
+	if(ast_test_flag(options, OPT_IGNORE_CONTEXT)){
+            create_dirpath(dir,sizeof(dir),"default",ext,"INBOX");
+	    create_dirpath(tmpdir,sizeof(tmpdir),"default",ext,"tmp");
+	    ast_copy_string(vmu->context,"default", sizeof(vmu->context));
+    	    ast_copy_string(chan->context,"default", sizeof(chan->context));
+            ast_log(LOG_DEBUG, "Option 'i' is used, context changed to '%s'\n", dir);
+        }		
 	ast_copy_string(fmt, vmfmts, sizeof(fmt));
 	if (!ast_strlen_zero(fmt)) {
 		msgnum = 0;
@@ -7628,6 +7638,8 @@
 					ast_set_flag(&flags, OPT_SILENT);
 				else if (*(args.argv0) == 'p')
 					ast_set_flag(&flags, OPT_PREPEND_MAILBOX);
+				else if (*(args.argv0) == 'i')
+                                        ast_set_flag(&flags, OPT_IGNORE_CONTEXT);
 				else 
 					break;
 				(args.argv0)++;
@@ -8131,7 +8143,7 @@
 		if (args.argc == 2) {
 			if (ast_app_parse_options(vm_app_options, &flags, opts, args.argv1))
 				return -1;
-			ast_copy_flags(&leave_options, &flags, OPT_SILENT | OPT_BUSY_GREETING | OPT_UNAVAIL_GREETING | OPT_DTMFEXIT);
+			ast_copy_flags(&leave_options, &flags, OPT_SILENT | OPT_BUSY_GREETING | OPT_UNAVAIL_GREETING | OPT_DTMFEXIT | OPT_IGNORE_CONTEXT);
 			if (ast_test_flag(&flags, OPT_RECORDGAIN)) {
 				int gain;
 
